(function () {
    "use strict";

    angular.module('core').controller('romaneioController', controller);
    controller.$inject = ['$scope', '$timeout', 'romaneioService', '$q', 'lookupService', '$state', '$alert'];

    function controller($scope, $timeout, romaneioService, $q, lookupService, $state, $alert) {
        $scope.initializeLayout('Romaneios de Mercadoria');
        
        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            novoRomaneio: false,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {
                        Codigo: null,
                        Filial: { Empresa: { Codigo: null, Nome: null, } },
                        Ativo: null,
                    },
                    faixaEmissao: { De: null, Ate: null },
                    faixaQuantidade: { De: null, Ate: null },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.toggleNovoRomaneio = function()
        {
            
            $scope.state.novoRomaneio = !$scope.state.novoRomaneio;
            if($scope.state.novoRomaneio)
            {
                $scope.prepareNew();
            }
        }


        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        }

        $scope.prepareNew = function () {
            
            romaneioService
                           .prepareNew().then(
                           function (response) {
                               if (response.Status < 0) {
                                   $scope.popups.addItem.carregando = false;
                                   ccccccc({ text: response.Message, title: $scope.Title });
                               } else {
                                    
                                   $scope.popups.add.data = response.Data;
                               }
                           },
                           function (_error) {
                               $scope.popups.addItem.carregando = false;
                               $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                           });

        }

        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                     
                    romaneioService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.refresh();

                                if (action == $scope.popups.add.saveAction.saveAndNew) {
                                    $scope.popups.add.steps.index = 0;
                                    $scope.popups.add.toggle();
                                }
                                else if (action == $scope.popups.add.saveAction.saveAndEdit) {
                                    $state.go("state-romaneio-edit", { id: response.Data.ID });
                                }
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                saveAction: {
                    save: 0,
                    saveAndNew: 1,
                    saveAndEdit: 2
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    romaneioService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                $scope.popups.add.ativo = false;
                            } else {
                                
                                $scope.popups.add.data = response.Data;
                                $timeout(function () { $('[ng-model*="popups.add.data.Fornecedor"]').focus(); });
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                steps: {
                    index: 0,
                    count: 1,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                }
            }
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            romaneioService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            romaneioService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            if ($scope.state.data == null || $scope.state.data.lenght == 0)
                return;
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            romaneioService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: {
                    Codigo: null,
                    Filial: { Empresa: { Codigo: null, Nome: null, } },
                    Ativo: null,
                },
                faixaEmissao: { De: null, Ate: null },
                faixaQuantidade: { De: null, Ate: null },
                sortExpression: '',
                skip: 0,
                take: 20
            }


            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();